<template>
  <GenericLayout class-names="bg-primary">
    <template #page-content>
      <div
        class="column flex-center text-grey"
        key="farm-loader"
      >
        <h6
          class="text-white"
        >
          <translate>
            Logging you out
          </translate>
        </h6>
        <q-spinner-dots
          color="white"
          size="40px"
        />
      </div>
    </template>
  </GenericLayout>
</template>
<script>
import GenericLayout from 'src/layouts/GenericLayout'
import mutationLogout from 'src/pages/logout/graphql/mutationLogout'
import { persistor } from 'src/graphql/apollo/cache'
import { logout as oauth2Logout } from 'src/services/authentication'
import { indexedDBHardClear } from 'src/utils/indexDB'
import { stopMobileServices } from 'src/services/mobile'
import { stopUploadService } from 'src/services/photo/upload'

export default {
  name: 'LogoutPage',
  components: {
    GenericLayout
  },
  methods: {
    async logout () {
      console.time('App logout')
      const apolloClient = this.$apollo.getClient()

      // Stop mobile services
      if (this.isMobileApp) {
        await stopMobileServices()
      } else {
        stopUploadService()
      }

      // Logout from Hasura if config is valid
      try {
        const isRefreshTokenConfigValid = this.$store.getters['fastplatform/isRefreshTokenConfigValid']
        if (apolloClient && isRefreshTokenConfigValid) {
          this.$apollo.mutate({
            mutation: mutationLogout
          })
        }
      } catch (e) {
        console.error('Logout from backend error', e)
      }

      // Logout from OAuth
      try {
        await oauth2Logout()
      } catch (e) {
        console.error('OAuth logout error', e)
      }

      // Stop Apollo client and clear cache
      try {
        if (apolloClient) {
        // stop client
          apolloClient.stop()
          // clear Apollo store
          await apolloClient.clearStore()
        }
        // pause and purge apollo cache persistor
        persistor.pause()
        await persistor.purge()
      } catch (e) {
        console.error('Apollo Cache clear error', e)
        // force clearing Apollo cache storage // TODO To fix it doesn't work
        await indexedDBHardClear(apolloClient)
      }

      // Reset Vuex store
      try {
        await this.$store.dispatch('reset')
      } catch (e) {
        console.error('Vuex store clear error', e)
        // Force clearing local storage
        window.localStorage.clear()
      }

      console.timeEnd('App logout')
    }
  },
  async mounted () {
    try {
      await this.logout()
    } catch (e) {
      console.error('Logout error', e)
    } finally {
      // redirect to the region selection page after logout
      this.$router.replace({ name: 'regionSelection' })
    }
  }
}
</script>
